#include <linux/module.h>
#include <linux/sched.h>
#include <asm/uaccess.h>
#include <linux/proc_fs.h>
#define SIZE 8192
static char *mybuf;
static unsigned long mybuf_mfn;
static int tg3_write_proc(struct file *file, const char *buffer,
			  unsigned long count, void *data)
{
	int len;
	if (count > SIZE)
		len = SIZE;
	else
		len = count;
	if (copy_from_user(mybuf, buffer, len))
		return -EFAULT;
	return len;
}
static int
tg3_read_proc(char *buf, char **start, off_t offset,
	      int count, int *eof, void *data)
{
	int len;
	if (offset >= SIZE)
		return 0;
	if (count + offset > SIZE)
		len = SIZE - offset;
	else
		len = count;
	printk("offset=0x%x, count=0x%x, len=0x%x\n", (int) offset, count,
	       len);
	memcpy(buf, mybuf + offset, len);
	*start = buf;
	if (offset + len >= SIZE)
		*eof = 1;
	else
		*eof = 0;
	return len;
}
static int
get_addr(char *buf, char **start, off_t offset,
	 int count, int *eof, void *data)
{
	int len;
	if (offset || count < 16) {
		*eof = 1;
		return 0;
	}
	len = sprintf(buf, "%p", mybuf_mfn);
	*eof = 1;
	return len;
}

//char smmcode[]="\xb8\x00\x00\x8e\xd8"
//        "\x66\xb8\xdd\xcc\xbb\xaa\x67\x66\xa3\x00\x00\x92\x35\x0f\xaa"; 

static int dpg_create_proc(void)
{
	struct proc_dir_entry *res =
	    create_proc_entry("mymem", 0600, NULL);
	res->read_proc = tg3_read_proc;
	res->write_proc = tg3_write_proc;
	res = create_proc_entry("mymem_addr", 0600, NULL);
	res->read_proc = get_addr;
	mybuf = kmalloc(SIZE, GFP_KERNEL);
//      memcpy(mybuf+0x8000, smmcode, 20);
	mybuf_mfn=__pa(mybuf);
	printk("mybuf va=%p, guest paddr=%p, machine addr=%p\n",
	       mybuf, __pa(mybuf), mybuf_mfn);
	return 0;
}

static void dpg_remove_proc(void)
{
	kfree(mybuf);
	remove_proc_entry("mymem_addr", NULL);
	remove_proc_entry("mymem", NULL);
}

module_init(dpg_create_proc);
module_exit(dpg_remove_proc);
MODULE_LICENSE("GPL");
